import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';

class TestWidget {
  final Widget? child;
  final WidgetTester? tester;
  BuildContext? context;

  TestWidget({
    this.child,
    this.tester,
  });

  Future<BuildContext> main() async {
    await tester!.pumpWidget(buildTestableWidget(child!));
    return context!;
  }

  Future<BuildContext> call() => main();

  Widget buildTestableWidget(Widget widget) => MediaQuery(
        data: MediaQueryData(size: Size(900, 900)),
        child: MaterialApp(home: Builder(
          builder: (c) {
            context = c;
            return widget;
          },
        )),
      );
}
